//id_addTabStopLump.jsx　2019.02.27　（z-）
//https://forums.adobe.com/thread/2416524　で皆さんに助言いただきました感謝感激雨鼻毛
//2019.02.28　ver_b
//2019.02.28　ver_c　CC2015〜でラジオボタンテキストが見えないのを修正
//2019.09.04　ver_d　選択範囲の左右中央の座標を取り込むボタンを増設
//2022.06.09　ver_e　表組（Table）が選択されていると動作しなかったのを修正


#target indesign
#targetengine "id_addTabStopLump"

function cp(mes){
    alert(mes);
    }

function clearInfo(){
    win.info.text = "info:";
    }

function doFunc(funcName){
    app.doScript(funcName, ScriptLanguage.JAVASCRIPT, [], UndoModes.FAST_ENTIRE_SCRIPT); 
    }

function getHorizontalLocate(val){
    if(app.selection.length == 0) return;
    var ins = app.selection[0];
    if(ins.parentStory.storyPreferences.storyOrientation == StoryHorizontalOrVertical.VERTICAL){
        win.info.text = "info: " + "すみません横組み専用なの";
        return;
        }
    if(ins.hasOwnProperty ("insertionPoint")){
        win.info.text = "info: " + "取り込み前にテキストを選択する";
        return;
        }
    var resL, resR, resC;
    resL = addRect(0);
    if(val == 2) {
        resR = addRect(-1);
        }
    resC = val == 2 ? (resL + resR) / 2 : resL;
    win.val.text = UnitValue(resC, "pt").as("mm");
    clearInfo();
    
    function addRect(ind) { /////////フォーラムであるふぁさんに提示してもらった部分/////////////
        var r0, an0, x0, x1;
        var ins = app.selection[0].insertionPoints[ind];
        r0 = ins.rectangles.add();
        an0 = r0.anchoredObjectSettings;
        an0.anchoredPosition = AnchorPosition.ANCHORED;
        an0.horizontalReferencePoint = AnchoredRelativeTo.COLUMN_EDGE;
        ins.recompose();
        x0 = r0.resolve(an0.anchorPoint,CoordinateSpaces.PARENT_COORDINATES)[0][0];
        an0.horizontalReferencePoint = AnchoredRelativeTo.ANCHOR_LOCATION;
        ins.recompose();
        x1 = r0.resolve(an0.anchorPoint,CoordinateSpaces.PARENT_COORDINATES)[0][0];
        r0.remove();
        return x1 - x0;
        }
    ////////////////////////////////////////////////////////////////
    }

//実装するか考え中
function modifyParagraphStyle(pos){}

function addTabStop(pos, align, chr, ldr){
    if(app.selection.length == 0) return;
    var sel = app.selection[0], tgt;
    if(sel.hasOwnProperty ("paragraphs") == false && sel.hasOwnProperty ("cells") == false){
       win.info.text = "info: " + "テキスト選択されてない";
        return;
        }
    if(sel.hasOwnProperty ("parentStory")){
        if(sel.parentStory.storyPreferences.storyOrientation == StoryHorizontalOrVertical.VERTICAL){
            win.info.text = "info: " + "すみません横組み専用なの";
            return;
            }
        }
    tgt = sel.hasOwnProperty ("cells") ? 
        app.selection[0].cells.everyItem().paragraphs.everyItem() : 
        app.selection[0].paragraphs.everyItem();
    tgt.tabStops.add({position : pos, alignment : align, alignmentCharacter : chr, leader : ldr});
    clearInfo();
    }

if(win == undefined){
var win = new Window("""palette{text : "ラクにタブ足すやつ", 
typeG : Group{orientation : "row", spacing : 0, 
    s : StaticText{text : "種類："}, 
    le : RadioButton{text : "左", enumStr : "LEFT_ALIGN", characters : 3}, 
    ce : RadioButton{text : "中", enumStr : "CENTER_ALIGN", characters : 3}, 
    ri : RadioButton{text : "右", enumStr : "RIGHT_ALIGN", characters : 3}, 
    ch : RadioButton{text : "任意文字", enumStr : "CHARACTER_ALIGN"}
}, 
optG : Group{orientation : "row", spacing : 0, 
    s : StaticText{text : "リーダー："}, 
    leader : EditText{characters : 5, justify : "center"}, 
    charaG : Group{orientation : "row", spacing : 0, 
        s : StaticText{text : "　　揃え文字："}, 
        alignChr : EditText{characters : 2, justify : "center", text : "."}
    }
}, 
capG : Group{orientation : "row", spacing : 0, 
    s : StaticText{text : "位置取り込み："}, 
    capL : Button{text : "先頭挿入点"}, 
    capC : Button{text : "左右中央"}
}, 
val : EditText{characters : 20, justify : "center"},
p : Panel{size : [220, 0]}, 
info : StaticText{text : "info: ", characters:30}, 
p : Panel{size : [220, 0]}, 
pb : Button{text : "please"}
}""");

var enumStr;

for(var i = 1; i < 5; i++){
    win.typeG.children[i].onClick = function(){
        enumStr = this.enumStr;
        }
    }

win.typeG.le.notify("onClick"); //初期値：左揃え

win.capG.capL.onClick = function(){ //先頭挿入点座標を取得
    doFunc("getHorizontalLocate(" + 1 + ")");
    app.activeDocument.undo();
    }

win.capG.capC.onClick = function(){ //先頭と末尾の平均値を取得
    doFunc("getHorizontalLocate(" + 2 + ")");
    app.activeDocument.undo();
    }

win.pb.onClick = function(){
    if(win.val.text.length == 0){
        win.info.text = "info: " + "位置入力または取り込め";
        return;
        }
    if(win.optG.charaG.alignChr.text.length == 0){ //空欄不可
        win.optG.charaG.alignChr.text = ".";
        }
    addTabStop(win.val.text, TabStopAlignment[enumStr], win.optG.charaG.alignChr.text, win.optG.leader.text);
    }
}

win.show();